<template>
  <sui-modal
    v-model="visible"
    size="mini"
    @displayChanged="onModalChanged"
    v-scroll-lock="visible"
    :animation-duration="1">

    <i
      class="close icon"
      @click="hide"/>
    <div class="header default padding gray">
      <div class="title">Войти</div>
    </div>
    <div class="content">
      <div class="kit authorization">
        <div class="form block">
          <form
            id="formAuthorization"
            class="ui form"
            method="post"
            :class="{loading: loading}"
            novalidate
            @submit.prevent="sendData()">
            <div class="field">
              <div class="ui icon input">
                <input
                  type="email"
                  placeholder="E-mail"
                  id="username"
                  name="username"
                  v-model="username">
                <i
                  class="link advanced icon remove"
                  v-erase-control="username"/>
              </div>
            </div>
            <div class="field">
              <div class="ui icon input">
                <input
                  type="password"
                  placeholder="Пароль"
                  minlength="6"
                  id="password"
                  name="password"
                  v-model="password">
                <i
                  class="link advanced icon eye"
                  v-password-control="'password'"/>
              </div>
              <div
                class="error message"
                v-if="error">
                {{ error }}
              </div>
            </div>
            <div class="field">
              <div class="link block">
                <a
                  role="button"
                  @click="hide();showResetPass()"
                  class="kit aqualink small nowrap float-left">Забыли пароль?
                </a>
              </div>
            </div>
            <div class="login button block">
              <button
                type="submit"
                :disabled="!valid"
                class="ui button yellow circular inmodal"
                id="button-enter-user"
                @click="$ga('Shag1','Click46'); $ym('modal_authorization_button_enter')">
                Войти
              </button>
            </div>
          </form>
        </div>
        <div class="actions">
          <div class="kit text center">
            <flink
              href="/users/register"
              domain="main"
              class="registration link"
              @click.native="$ga('Shag2','Click47');$ym('modal_authorization_button_register') ">
              Зарегистрироваться
            </flink>
          </div>
        </div>
      </div>
    </div>
  </sui-modal>
</template>

<script>
import { has } from 'lodash-es';
import { createNamespacedHelpers } from 'vuex';

import {
  SHOW_AUTH_MODAL,
  HIDE_AUTH_MODAL,
  SHOW_RESET_PASSWORD_MODAL,
} from '~/assets/js/store/actionManager/mutation-types';
import { LOGIN } from '~/assets/js/store/user/action-types';
import Validator from '~/assets/js/validator';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'AuthModal',
  data() {
    return {
      username: '',
      password: '',
      rememberMe: null,
      loading: false,
      error: false,
    };
  },
  computed: {
    ...STORE_ACTION_MANAGER.mapState({
      shown: 'authModalShow',
    }),
    visible: {
      get() {
        return this.shown;
      },
      set(newVal) {
        if (newVal) {
          this.show();
        } else {
          this.hide();
        }
      },
    },
    valid() {
      return Validator.notBlank(this.username) && Validator.notBlank(this.password);
    },
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      show: SHOW_AUTH_MODAL,
      hide: HIDE_AUTH_MODAL,
      showResetPass: SHOW_RESET_PASSWORD_MODAL,
    }),
    ...STORE_USER.mapActions({
      login: LOGIN,
    }),
    onModalChanged() {
      this.username = '';
      this.password = '';
      this.error = null;
      this.loading = false;
    },
    sendData() {
      this.loading = true;
      this.error = null;
      this.login({
        username: this.username,
        password: this.password,
      }).then(() => {
        this.visible = false;
      }).catch((xhr) => {
        const { data } = xhr.response;
        if (has(data, 'message') && data.message) {
          if (data.error.errorCode === 401) {
            this.error = data.message;
          } else {
            this.error = 'Произошла ошибка, пожалуйста, попробуйте повторить запрос позднее';
          }
        }
      }).finally(() => {
        this.loading = false;
      });
    },
  },
};
</script>

<style scoped lang="scss">
  .kit.authorization {
    i.icon.eye {
      font-size: 1.125rem;
      color: #c5d1d9;
      opacity: 1 !important;
    }
    .form.block {
      #password[type='password'] + i.icon.eye:before {
        content: '◇';
      }
      #password[type='text'] + i.icon.eye:before {
        content: '◈';
      }
      .login.button.block {
        margin: 0 auto;
        max-width: 14em;
        button {
          margin: 2rem auto;
          width: 100%;
        }
      }
      .link.block {
        display: block;
        padding-top: 0.25rem;
        .ui.checkbox, .kit.aqualink {
          margin-bottom: 0.375rem;
        }
        .kit.aqualink.small {
          font-size: .8125rem;
          @media only screen and (max-width: 1024px) {
            font-size: .9375rem;
          }
        }
        .float-right {
          float: right;
        }

        @media only screen and (max-width: 345px) {
          .kit.aqualink {
            float: none;
            display: block;
            width: fit-content;
            margin-top: 0.5rem;
            margin-bottom: 1.5rem;
          }
        }
      }
    }
    .actions {
      text-align: center;
      .registration.link {
        font-size: 1rem;
        font-weight: 500;
        text-align: center;
        background: #4272A4;
        display: block;
        margin: 0em -2rem -1.5em;
        padding-top: 1.5em;
        padding-bottom: 1.5em;
        border-top: 1px solid #9badb9;
        color: #ffffff;
        &:hover {
          color: #ffffff;
          background-color: #345A81;
        }
      }
    }
    @media screen and (max-width: 767px) {
      .actions {
        .registration.link {
          margin: 0em -1.5rem -1.5em;
        }
      }
    }
  }
</style>
